Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.timer
Interface TimerMBean

All Known Implementing Classes:
  Timer

public interface TimerMBean

Exposes the management interface of the timer MBean.

Author:
  Young Yang

Method Summary
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date)` Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and a null period and number of occurences.
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date, long period)` Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and period and a null number of occurences.
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date, long period, long nbOccurences)` Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date, period and number of occurences.
`java.lang.Integer` | `addNotification(java.lang.String type, java.lang.String message, java.lang.Object userData, java.util.Date date, long period, long nbOccurences, boolean fixedRate)` Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date, period and number of occurences.
`java.util.Vector` | `getAllNotificationIDs()` Gets all timer notification identifiers registered into the list of notifications.
`java.util.Date` | `getDate(java.lang.Integer id)` Gets a copy of the date associated to a timer notification.
`java.lang.Boolean` | `getFixedRate(java.lang.Integer id)` Gets a copy of the flag indicating whether a peridic notification is executed at fixed-delay or at fixed-rate.
`int` | `getNbNotifications()` Gets the number of timer notifications registered into the list of notifications.
`java.lang.Long` | `getNbOccurences(java.lang.Integer id)` Gets a copy of the remaining number of occurences associated to a timer notification.
`java.util.Vector` | `getNotificationIDs(java.lang.String type)` Gets all the identifiers of timer notifications corresponding to the specified type.
`java.lang.String` | `getNotificationMessage(java.lang.Integer id)` Gets the timer notification detailed message corresponding to the specified identifier.
`java.lang.String` | `getNotificationType(java.lang.Integer id)` Gets the timer notification type corresponding to the specified identifier.
`java.lang.Object` | `getNotificationUserData(java.lang.Integer id)` Gets the timer notification user data object corresponding to the specified identifier.
`java.lang.Long` | `getPeriod(java.lang.Integer id)` Gets a copy of the period (in milliseconds) associated to a timer notification.
`boolean` | `getSendPastNotifications()` Gets the flag indicating whether or not the timer sends past notifications.
`boolean` | `isActive()` Tests whether the timer MBean is active.
`boolean` | `isEmpty()` Tests whether the list of timer notifications is empty.
`void` | `removeAllNotifications()` Removes all the timer notifications from the list of notifications and resets the counter used to update the timer notification identifiers.
`void` | `removeNotification(java.lang.Integer id)` Removes the timer notification corresponding to the specified identifier from the list of notifications.
`void` | `removeNotifications(java.lang.String type)` Removes all the timer notifications corresponding to the specified type from the list of notifications.
`void` | `setSendPastNotifications(boolean value)` Sets the flag indicating whether the timer sends past notifications or not.
`void` | `start()` Starts the timer.
`void` | `stop()` Stops the timer.

Method Detail

### start

    public void start()

  Starts the timer.

  If there is one or more timer notifications before the time in the list of notifications, the notification is sent according to the `sendPastNotifications` flag and then, updated according to its period and remaining number of occurences. If the timer notification date remains earlier than the current date, this notification is just removed from the list of notifications.

### stop

    public void stop()

  Stops the timer.

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date,
                                             long period,
                                             long nbOccurences,
                                             boolean fixedRate)
                                      throws java.lang.IllegalArgumentException

  Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date, period and number of occurences.

  If the timer notification to be inserted has a date that is before the current date, the method behaves as if the specified date were the current date.
  For once-off notifications, the notification is delivered immediately.
  For periodic notifications, the first notification is delivered immediately and the subsequent ones are spaced as specified by the period parameter.

  Note that once the timer notification has been added into the list of notifications, its associated date, period and number of occurences cannot be updated.

  In the case of a periodic notification, the value of parameter fixedRate is used to specify the execution scheme, as specified in `Timer`.

  Parameters:
    `type` - The timer notification type.
    `message` - The timer notification detailed message.
    `userData` - The timer notification user data object.
    `date` - The date when the notification occurs.
    `period` - The period of the timer notification (in milliseconds).
    `nbOccurences` - The total number the timer notification will be emitted.
    `fixedRate` - If `true` and if the notification is periodic, the notification is scheduled with a fixed-rate execution scheme. If `false` and if the notification is periodic, the notification is scheduled with a fixed-delay execution scheme. Ignored if the notification is not periodic.
  Returns:
    The identifier of the new created timer notification.
  Throws:
    `java.lang.IllegalArgumentException` - The period or the number of occurences is negative
  See Also:
    `addNotification(String, String, Object, Date, long, long)`

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date,
                                             long period,
                                             long nbOccurences)
                                      throws java.lang.IllegalArgumentException

  Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date, period and number of occurences.

  If the timer notification to be inserted has a date that is before the current date, the method behaves as if the specified date were the current date.
  For once-off notifications, the notification is delivered immediately.
  For periodic notifications, the first notification is delivered immediately and the subsequent ones are spaced as specified by the period parameter.

  Note that once the timer notification has been added into the list of notifications, its associated date, period and number of occurences cannot be updated.

  In the case of a periodic notification, uses a fixed-delay execution scheme, as specified in `Timer`. In order to use a fixed-rate execution scheme, use `addNotification(String, String, Object, Date, long, long, boolean)` instead.

  Parameters:
    `type` - The timer notification type.
    `message` - The timer notification detailed message.
    `userData` - The timer notification user data object.
    `date` - The date when the notification occurs.
    `period` - The period of the timer notification (in milliseconds).
    `nbOccurences` - The total number the timer notification will be emitted.
  Returns:
    The identifier of the new created timer notification.
  Throws:
    `java.lang.IllegalArgumentException` - The period or the number of occurences is negative
  See Also:
    `addNotification(String, String, Object, Date, long, long, boolean)`

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date,
                                             long period)
                                      throws java.lang.IllegalArgumentException

  Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and period and a null number of occurences.

  The timer notification will repeat continuously using the timer period using a fixed-delay execution scheme, as specified in `Timer`. In order to use a fixed-rate execution scheme, use `addNotification(String, String, Object, Date, long, long, boolean)` instead.

  If the timer notification to be inserted has a date that is before the current date, the method behaves as if the specified date were the current date. The first notification is delivered immediately and the subsequent ones are spaced as specified by the period parameter.

  Parameters:
    `type` - The timer notification type.
    `message` - The timer notification detailed message.
    `userData` - The timer notification user data object.
    `date` - The date when the notification occurs.
    `period` - The period of the timer notification (in milliseconds).
  Returns:
    The identifier of the new created timer notification.
  Throws:
    `java.lang.IllegalArgumentException` - The period is negative or the date notification is before the current date.

### addNotification

    public java.lang.Integer addNotification(java.lang.String type,
                                             java.lang.String message,
                                             java.lang.Object userData,
                                             java.util.Date date)
                                      throws java.lang.IllegalArgumentException

  Creates a new timer notification with the specified `type`, `message` and `userData` and inserts it into the list of notifications with a given date and a null period and number of occurences.

  The timer notification will be handled once at the specified date.

  If the timer notification to be inserted has a date that is before the current date, the method behaves as if the specified date were the current date and the notification is delivered immediately.

  Parameters:
    `type` - The timer notification type.
    `message` - The timer notification detailed message.
    `userData` - The timer notification user data object.
    `date` - The date when the notification occurs.
  Returns:
    The identifier of the new created timer notification.
  Throws:
    `java.lang.IllegalArgumentException` - The date notification is before the current date.

### removeNotification

    public void removeNotification(java.lang.Integer id)
                            throws InstanceNotFoundException

  Removes the timer notification corresponding to the specified identifier from the list of notifications.

  Parameters:
    `id` - The timer notification identifier.
  Throws:
    `InstanceNotFoundException` - The specified identifier does not correspond to any timer notification in the list of notifications of this timer MBean.

### removeNotifications

    public void removeNotifications(java.lang.String type)
                             throws InstanceNotFoundException

  Removes all the timer notifications corresponding to the specified type from the list of notifications.

  Parameters:
    `type` - The timer notification type.
  Throws:
    `InstanceNotFoundException` - The specified type does not correspond to any timer notification in the list of notifications of this timer MBean.

### removeAllNotifications

    public void removeAllNotifications()

  Removes all the timer notifications from the list of notifications and resets the counter used to update the timer notification identifiers.

### getNbNotifications

    public int getNbNotifications()

  Gets the number of timer notifications registered into the list of notifications.

  Returns:
    The number of timer notifications.

### getAllNotificationIDs

    public java.util.Vector getAllNotificationIDs()

  Gets all timer notification identifiers registered into the list of notifications.

  Returns:
    A vector of `Integer` objects containing all the timer notification identifiers.
    The vector is empty if there is no timer notification registered for this timer MBean.

### getNotificationIDs

    public java.util.Vector getNotificationIDs(java.lang.String type)

  Gets all the identifiers of timer notifications corresponding to the specified type.

  Parameters:
    `type` - The timer notification type.
  Returns:
    A vector of `Integer` objects containing all the identifiers of timer notifications with the specified `type`.
    The vector is empty if there is no timer notifications registered for this timer MBean with the specified `type`.

### getNotificationType

    public java.lang.String getNotificationType(java.lang.Integer id)

  Gets the timer notification type corresponding to the specified identifier.

  Parameters:
    `id` - The timer notification identifier.
  Returns:
    The timer notification type or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getNotificationMessage

    public java.lang.String getNotificationMessage(java.lang.Integer id)

  Gets the timer notification detailed message corresponding to the specified identifier.

  Parameters:
    `id` - The timer notification identifier.
  Returns:
    The timer notification detailed message or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getNotificationUserData

    public java.lang.Object getNotificationUserData(java.lang.Integer id)

  Gets the timer notification user data object corresponding to the specified identifier.

  Parameters:
    `id` - The timer notification identifier.
  Returns:
    The timer notification user data object or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getDate

    public java.util.Date getDate(java.lang.Integer id)

  Gets a copy of the date associated to a timer notification.

  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the date or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getPeriod

    public java.lang.Long getPeriod(java.lang.Integer id)

  Gets a copy of the period (in milliseconds) associated to a timer notification.

  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the period or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getNbOccurences

    public java.lang.Long getNbOccurences(java.lang.Integer id)

  Gets a copy of the remaining number of occurences associated to a timer notification.

  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the remaining number of occurences or null if the identifier is not mapped to any timer notification registered for this timer MBean.

### getFixedRate

    public java.lang.Boolean getFixedRate(java.lang.Integer id)

  Gets a copy of the flag indicating whether a peridic notification is executed at fixed-delay or at fixed-rate.

  Parameters:
    `id` - The timer notification identifier.
  Returns:
    A copy of the flag indicating whether a peridic notification is executed at fixed-delay or at fixed-rate.

### getSendPastNotifications

    public boolean getSendPastNotifications()

  Gets the flag indicating whether or not the timer sends past notifications.

  Returns:
    The past notifications sending on/off flag value.
  See Also:
    `setSendPastNotifications(boolean)`

### setSendPastNotifications

    public void setSendPastNotifications(boolean value)

  Sets the flag indicating whether the timer sends past notifications or not.

  Parameters:
    `value` - The past notifications sending on/off flag value.
  See Also:
    `getSendPastNotifications()`

### isActive

    public boolean isActive()

  Tests whether the timer MBean is active. A timer MBean is marked active when the `start` method is called. It becomes inactive when the `stop` method is called.

  Returns:
    `true` if the timer MBean is active, `false` otherwise.

### isEmpty

    public boolean isEmpty()

  Tests whether the list of timer notifications is empty.

  Returns:
    `true` if the list of timer notifications is empty, `false` otherwise.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD